#ifndef atol_h__included
#define atol_h__included

#include "app_opt.h"

#include <windows.h>
#include "file_io.h"
#include "atom_table.h"
#include "console.h"
#include "atol_interface.h"
#include "str.h"
#include "all_atoms.h"

#include "resource.h"

// directives

#pragma comment(linker,"/NODEFAULTLIB")
#pragma comment(linker,"/ENTRY:main")
#pragma comment(linker,"/FILEALIGN:512")
#pragma comment(linker,"/MERGE:.data=.text")
#pragma comment(linker,"/MERGE:.rdata=.text")
#pragma comment(linker,"/SECTION:.text,ERWX")
#pragma comment(linker,"/IGNORE:4078")

// types

typedef char path_t [MAX_PATH];

// prototypes

void locate_targets();
void check_for_help();
char * get_file_ext_dot(char * str);
void open_targets();
void compile_targets();
void run_targets();
void close_targets();
void engine_compile(int file, char *fn);
void engine_compile(const char *fn);
void engine_include(const char *fname); // INCLUDE A FILE (ATOL OR ATOC)
void engine_run();
int s2i(char *);
char * i2s(int x, char * s);
void load_libs();
void setup_interface();
void after_compile_work();

//void print_expression(list_s*);

extern ATOL_INTERFACE_S  IAtol; // ATOL Interface.

atom_s * __fastcall register_extern(char * name, void *adr);

void save_compiled(int f);
void load_compiled(int f); // load compiled file.
void load_compiled(const char *); // load compiled file.

// CRYPT FUNC.
void file_io_write_encrypted(int file, void *buf, int size);
void file_io_read_encrypted(int file, void *buf, int size);
void file_io_read_encrypted_str(int file, char *buf);
void file_io_read_encrypted_str(int file, str_s &buf);
void crypt_start();
void crypt_finish();

// log:
void Log(char *msg, ...);

// OBJECT SUPPORT:
list_s * obj_new(atom_s *obj_name, atom_s *obj_class);
atom_s * obj_class(atom_s *obj_name);
atom_s * obj_property(atom_s *obj_name, atom_s *prop_name);
atom_s * obj_set_property(atom_s *obj_name, atom_s *prop_name, atom_s *val);

unsigned int rnd();

atom_s * __fastcall engine_run_func(list_s *p, int FLAG = 0, int RunArgs = 1);

extern scope_s *current_scope;


#endif // atol_h__included
