// this realizes encryption file i/o.
#include "atol.h"

static const unsigned char key [512] =
{
	94, 234, 194, 96, 228, 234, 20, 234, 253, 8, 233, 209, 252, 76, 80, 116, 
	50, 154, 234, 22, 222, 211, 239, 154, 89, 43, 130, 128, 129, 204, 57, 31, 
	101, 172, 231, 36, 50, 171, 173, 74, 93, 240, 63, 91, 17, 132, 122, 102, 
	219, 47, 38, 66, 147, 146, 8, 66, 141, 133, 43, 57, 179, 111, 176, 
	182, 115, 82, 102, 244, 232, 252, 8, 172, 91, 145, 49, 224, 215, 178, 164, 
	89, 5, 84, 200, 137, 74, 197, 99, 188, 30, 251, 154, 133, 175, 30, 40, 
	104, 182, 88, 222, 195, 152, 220, 91, 2, 192, 53, 11, 2, 58, 207, 101, 
	197, 147, 202, 96, 87, 241, 254, 53, 255, 109, 73, 91, 169, 184, 32, 192
};

int ikey = 0;
int crypted_size = 0;

void file_io_write_encrypted(int file, void *buf, int size)
{
	unsigned char *p = (unsigned char *) buf;
	unsigned char x;

	for (int i = 0; i < size; ++i)
	{
		x = p [i] ^ key [ikey];
		++ikey;
		if (ikey >= 512) ikey = 0;
		x = (x << 4) | (x >> 4); // swap high 4 bits and low 4 bits.
		file_io_write(file, &x, 1); // byte-wise writing.
		++crypted_size;
	}
}

void file_io_read_encrypted(int file, void *buf, int size)
{
	unsigned char *p = (unsigned char *) buf;
	unsigned char x;

	for (int i = 0; i < size; ++i)
	{
		x = (unsigned char) file_io_get_char(file);
		x = (x << 4) | (x >> 4); // swap high 4 bits and low 4 bits.
		p [i] = x ^ key [ikey];
		++ikey;
		if (ikey >= 512) ikey = 0;
		++crypted_size;
	}
}

void crypt_start()
{
	ikey = crypted_size = 0;
}

void crypt_finish()
{
//	char msg [16];
//	wsprintf(msg, "n = %i", crypted_size);
//	MessageBox(NULL, msg, NULL, 0);
}

void file_io_read_encrypted_str(int file, char *buf)
{
	unsigned char *p = (unsigned char *) buf;
	unsigned char x;

	for (int i = 0; ; ++i)
	{
		x = (unsigned char) file_io_get_char(file);
		x = (x << 4) | (x >> 4); // swap high 4 bits and low 4 bits.
		p [i] = x ^ key [ikey];
		++ikey;
		if (ikey >= 512) ikey = 0;
		++crypted_size;
		if (p[i] == 0) return; // till first zero symbol.
	}
}

void file_io_read_encrypted_str(int file, str_s &buf)
{
	register unsigned char x, p;
	buf.empty();

	for (; ;)
	{
		x = (unsigned char) file_io_get_char(file);
		x = (x << 4) | (x >> 4); // swap high 4 bits and low 4 bits.
		p = x ^ key [ikey];
		buf.append(p);
		++ikey;
		if (ikey >= 512) ikey = 0;
		++crypted_size;
		if (p == 0) return; // till first zero symbol.
	}
}
