// file to support objects.
#include "atol.h"

static list_s * OBJECTS = NULL;

extern atom_s *std_atom_class, *std_atom_null;

list_s * obj_new(atom_s *obj_name, atom_s *obj_class)
{
	register list_s *p = list_add(&OBJECTS, obj_name);
	list_push(&(p->sublist), std_atom_class)->sublist = (list_s *) obj_class;
	return p;
}

atom_s * obj_class(atom_s *obj_name)
{
	register list_s *p = list_find(OBJECTS, obj_name);
	if (!p) return NULL;
	register list_s *r = list_find(p->sublist, std_atom_class);
	Error(!r, "internal: object without class");
	return (atom_s *) r->sublist;
}

atom_s * obj_property(atom_s *obj_name, atom_s *prop_name)
{
	register list_s *p = list_find(OBJECTS, obj_name);
	Error(!p, IDS_NO_OBJECT, obj_name->name);
	p = list_find(p->sublist, prop_name);
	return p?((atom_s *) p->sublist):std_atom_null;
}

atom_s * obj_set_property(atom_s *obj_name, atom_s *prop_name, atom_s *val)
{
	register list_s *p = list_find(OBJECTS, obj_name);
	Error(!p, IDS_NO_OBJECT, obj_name->name);
	register list_s *r = list_find(p->sublist, prop_name);

	if (!r) r = list_push(&(p->sublist), prop_name);

	r->sublist = (list_s*) val;

	return val;
}
