/// INCLUDED FILE, NOT STANDING ALONE ///

/*** LOAD STD ATOMS ***/

atom_s * __fastcall register_extern(char * name, void *adr)
{
	register atom_s *p = atoms_add(name);
	p->set_flag(atom_info_external | atom_info_function);
	p->body = (list_s *) adr;
	return p;
}

void __fastcall set_init_var(atom_s *var_name, char *var_value)
{
	register list_s **ptr = &(list_add(&(std_atom_initialize->body), std_atom_set)->sublist);
	list_push(ptr, atoms_add(var_value));
	list_push(ptr, var_name);
}

static const struct { atom_s **var; char *name; void *func; } ALL_ATOMS [] =
{
	&std_atom_write,		"write",		atol_write,
	&std_atom_writenl,		"writenl",		atol_writenl,
	&std_atom_writeln,		"writeln",		atol_writenl,
	&std_atom_nl,			"nl",			atol_nl,

	&std_atom_eol,			"eol",			atol_eol,

	&std_atom_read,			"read",			atol_read,
	&std_atom_readchar,		"readchar",		atol_readchar,

	&std_atom_if,			"if",			atol_if,
	&std_atom_with,			"with",			atol_with,

	&std_atom_trace,		"trace",		atol_trace,
	&std_atom_notrace,		"notrace",		atol_notrace,
	&std_atom_spy,			"spy",			atol_spy,

	&std_atom_eq,			"eq",			atol_eq,
	&std_atom_eqi,			"eqi",			atol_eqi,
	&std_atom_eqf,			"eqf",			atol_eqf,
	&std_atom_at,			"at",			atol_at,

	&std_atom_gettag,		"get_tag",		atol_gettag,
	&std_atom_settag,		"set_tag",		atol_settag,

	&std_atom_body,			BODY_STR,		atol_body,
	&std_atom_set,			"set",			atol_set,
	&std_atom_var,			"var",			atol_var,
	&std_atom_g_var,		"g_var",		atol_g_var,
	&std_atom_new,			"new",			atol_new,
	&std_atom_g_new,		"g_new",		atol_g_new,

	&std_atom_append,		"append",		atol_append,
	&std_atom_concat,		"concat",		atol_concat,
	&std_atom_left,			"left",			atol_left,
	&std_atom_right,		"right",		atol_right,
	&std_atom_middle,		"middle",		atol_middle,
	&std_atom_length,		"length",		atol_length,
	&std_atom_reverse,		"reverse",		atol_reverse,
	&std_atom_head,			"head",			atol_head,
	&std_atom_tail,			"tail",			atol_tail,
	&std_atom_last,			"last",			atol_last,
	&std_atom_like,			"like",			atol_like,

	&std_atom_not,			"not",			atol_not,
	&std_atom_and,			"and",			atol_and,
	&std_atom_or,			"or",			atol_or,

	&std_atom_return,		"return",		atol_return,
	&std_atom_assert,		"assert",		atol_assert,
	&std_atom_NULL,			"null",			atol_null,

	&std_atom_eval,			"eval",			atol_eval,
	&std_atom_include,		"include",		atol_include,

	&std_atom_call,			"call",			atol_call,

	&std_atom_rnd,			"rnd",			atol_rnd,
	&std_atom_shell,		"shell",		atol_shell,
	&std_atom_sleep,		"sleep",		atol_sleep,

	&std_atom_version,		"atol.version",	atol_version,
	&std_atom_about,		"atol.about",	atol_about,
	&std_atom_gettime,		"get_time",		atol_gettime,
	&std_atom_atom_num,		"atol.number_of_atoms", atol_atom_num

};

static const struct { atom_s **var; char *name; } JUST_ATOMS [] =
{
	&std_atom_null,			"",
	&std_atom_true,		 	"true",
	&std_atom_main,			"main",
	&std_atom_mark,			MARK_STR,
	&std_atom_else,		    "else",
	&std_atom_module,		"module",
	&std_atom_class,		"class",
	&std_atom_initialize,	"atol.initialize",
	&std_atom_do,			"do",
	&std_atom_EOL,			"\r\n",
	&std_atom_cmd_line,		"command_line",
	&std_atom_rnd_set,		"rnd.symbols"
};


void load_std_atoms()
{
#ifdef APP_OPT_DEBUG
	console_log(">LOAD STD ATOMS");
#endif

	// register just atoms
	for (register int i = 0; i < sizeof(JUST_ATOMS)/sizeof(JUST_ATOMS[0]); ++i)
		*(JUST_ATOMS [i] .var) = atoms_add(JUST_ATOMS [i] .name);

	// register std functions.
	for (i = 0; i < sizeof(ALL_ATOMS)/sizeof(ALL_ATOMS[0]); ++i)
		*(ALL_ATOMS [i] .var) = register_extern(ALL_ATOMS [i] .name, ALL_ATOMS [i] .func);

	// set some flags:
	std_atom_initialize->set_flag(atom_info_function);

	// --- ADD SOME CODE INTO ATOL.INITIALIZE: ---
	register list_s **ptr = &(list_add(&(std_atom_initialize->body), std_atom_g_var)->sublist);

	list_push(ptr, std_atom_cmd_line);
	list_push(ptr, std_atom_rnd_set);
	list_push(ptr, atoms_add("_"));		// noname-variable.

	set_init_var(std_atom_cmd_line, GetCommandLine());
	set_init_var(std_atom_rnd_set, "0123456789");


#ifdef APP_OPT_DEBUG
	console_log(">END");
#endif
}
