// (INCLUDED FILE, NOT STANDING ALONE)

atom_s ** __fastcall get_dest(list_s * &args, list_s * &params, int expected)
{
	static atom_s * tmp;

	if (list_length(args) > expected)
	{
		args = args->next;
		register list_s *p = params;
		params = p->next;
		return current_scope->var_value(p->item);
	}
	return &tmp;
}

// Standard (embedded) functions.

atol_func(atol_write)
{
	for (register list_s *p = Args; p; p = p->next)
		console_write_str(p->item->name.str, p->item->name.len);
	return std_atom_null;
}

atol_func(atol_nl)
{
	console_write_str("\r\n", 2);
	return std_atom_null;
}

atol_func(atol_writenl)
{
	atol_write(IAtol, Args, Params);
	console_write_str("\r\n", 2);
	return std_atom_null;
}

atol_func(atol_read)
{
	char buf [1024];
	console_read(buf, sizeof(buf)-1);
	return *get_dest(Args, Params, 0) = atoms_add(buf);
}

atol_func(atol_readchar)
{
	return *get_dest(Args, Params, 0) = atoms_add((char) console_read_char());
}

atol_func(atol_body)
{
#ifdef APP_OPT_DEBUG
		console_log("DONT RUN");
#endif
	return std_atom_null;
}

atol_func(atol_eq)
{
	for (register list_s *p = Args; p->next; p = p->next)
		if (p->item != p->next->item) return std_atom_null;
	return std_atom_true;
}

atol_func(atol_eqi)
{
	for (register list_s *p = Args; p->next; p = p->next)
		if (p->item->name.neqi(p->next->item->name)) return std_atom_null;
	return std_atom_true;
}

atol_func(atol_eqf)
{
	for (register list_s *p = Args; p->next; p = p->next)
		if (p->item->name.neqf(p->next->item->name)) return std_atom_null;
	return std_atom_true;
}

atol_func(atol_if)
{
	register atom_s *ret = std_atom_null;
	scope_s scope(&current_scope, std_atom_null);

	if (Args->item != std_atom_null) // IF .. THEN ..
		ret = engine_run_func(Params->next->sublist);
	else if (Params->next->next)	// ELSE ..
		ret = engine_run_func(Params->next->next->sublist);

	scope.done();
	return ret;
}

atol_func(atol_with)
{
	scope_s scope(&current_scope, Args->item);
	register atom_s * ret = engine_run_func(Params->next->sublist);
	scope.done();
	return ret;
}

atol_func(atol_var)
{
	for (register list_s *p = Params; p; p = p->next)
		current_scope->new_var(p->item, std_atom_null);
	return std_atom_null;
}

atol_func(atol_g_var)
{
	for (register list_s *p = Params; p; p = p->next)
		global_scope.new_var(p->item, std_atom_null);
	return std_atom_null;
}

atol_func(atol_set)
{
	return *(current_scope->var_value(Params->item)) = Args->next->item;
}

atol_func(atol_new)
{
	return current_scope->new_var(Params->item, Args->next->item);
}

atol_func(atol_g_new)
{
	return global_scope.new_var(Params->item, Args->next->item);
}

atol_func(atol_concat)
{
	STR_S(atom);
	for (register list_s *p = Args; p; p = p->next) atom.concat(p->item->name);
	return atoms_add(&atom);
}

atol_func(atol_append)
{
	return *(current_scope->var_value(Params->item)) = atol_concat(IAtol, Args->next, Params->next);
}

atol_func(atol_left)
{
	register atom_s **dest = get_dest(Args, Params, 2);
	STR_S_(atom, Args->next->item->name);
	return *dest = atoms_add(atom.left(s2i(Args->item->name.str)));
}

atol_func(atol_at)
{
	register atom_s **dest = get_dest(Args, Params, 2);
	char buf [2] = { Args->next->item->name.at(Args->item->name.to_int()), 0 };
	return *dest = atoms_add(buf);
}

atol_func(atol_like)
{
	register atom_s **dest = get_dest(Args, Params, 2);
	if (str_like(Args->next->item->name.str, Args->item->name.str)) return *dest = std_atom_true;
	return *dest = std_atom_null;
}

atol_func(atol_right)
{
	register atom_s **dest = get_dest(Args, Params, 2);
	STR_S_(atom, Args->next->item->name);
	return *dest = atoms_add(atom.right(s2i(Args->item->name.str)));
}

atol_func(atol_middle) // delete([Res] St N Atom)
{
	register atom_s **dest = get_dest(Args, Params, 3);
	STR_S_(atom, Args->next->next->item->name);
	*dest = atoms_add(str_middle(atom.str, Args->next->next->item->name.str,
						s2i(Args->item->name.str),
						s2i(Args->next->item->name.str)));
	atom.free();
	return *dest;
}

atol_func(atol_not)
{
	register atom_s **dest = get_dest(Args, Params, 1);
	return *dest = (Args->item == std_atom_null)?std_atom_true:std_atom_null;
}

atol_func(atol_and)
{
	for (list_s *p = Args; p; p = p->next)
		if (p->item == std_atom_null) return std_atom_null;
	return std_atom_true;
}

atol_func(atol_or)
{
	for (list_s *p = Args; p; p = p->next)
		if (p->item != std_atom_null) return std_atom_true;
	return std_atom_null;
}

atol_func(atol_length)
{
	register atom_s **dest = get_dest(Args, Params, 1);
	str_s s;
	return *dest = atoms_add(s.init(Args->item->name.len));
}

atol_func(atol_reverse)
{
	register atom_s **dest = get_dest(Args, Params, 1);
	STR_S_(atom, Args->item->name);
	return *dest = atoms_add(atom.reverse());
}

atol_func(atol_return)
{
	++RETURN;
	if (Args) return RETURN_R = Args->item;
	return RETURN_R = std_atom_null;
}

atol_func(atol_head)
{
	register atom_s **dest = get_dest(Args, Params, 1);
	return *dest = atoms_add(Args->item->name.str [0]);
}

atol_func(atol_tail)
{
	register atom_s **dest = get_dest(Args, Params, 1);
	return *dest = (Args->item->name.str [0])?atoms_add(Args->item->name.str + 1):std_atom_null;
}

atol_func(atol_last)
{
	register atom_s **dest = get_dest(Args, Params, 1);
	register str_s *s = &(Args->item->name);
	return *dest = atoms_add( s->str [s->len - 1] );
}

atol_func(atol_assert)
{
	if (Args->item == std_atom_null)
	{
		console_write("(!) --- Assertion failed ---\n");
		atol_writenl(IAtol, Args->next, Params->next);
		console_write("Press any key to exit...\n");
		console_read_char();
		ExitProcess(3);
	}
	return Args->item;
}

atol_func(atol_null)
{
	for (register list_s *p = Params; p; p = p->next)
		*(current_scope->var_value(p->item)) = std_atom_null;
	return std_atom_null;
}

#include "eval.cpp" // include eval() func.


atol_func(atol_include) // include file.
{
	for (register list_s *p = Args; p; p = p->next) engine_include(p->item->name.str);
	return std_atom_null;
}

atol_func(atol_about)
{
	MessageBox(NULL,
		"ATOL programming language.\n\n"
		"Version "ATOL_VERSION"\n\n"
		"(C) 2005, Written by Alexander G. Karpov [a.k.a. mrhx]\n\n"
		"http://mrhx.narod.ru\n\n"
		"-----------------------------------------------------------------\n"
		__DATE__". Saint Petersburg, Russia.\n"
		,"About ATOL...",
		MB_OK | MB_TOPMOST | MB_ICONINFORMATION);

	return std_atom_null;
}

atol_func(atol_version)
{
	return *get_dest(Args, Params, 0) = atoms_add(ATOL_VERSION);
}

atol_func(atol_atom_num)
{
	str_s s;
	return *get_dest(Args, Params, 0) = atoms_add(s.init(atoms_count()));
}

atol_func(atol_gettime)
{
	str_s s;

	if (!Params) return atoms_add(s.init(GetTickCount()));

	register list_s *p = Params;
	SYSTEMTIME t;
	GetLocalTime(&t);

	*(current_scope->var_value(p->item)) = atoms_add(s.init(t.wHour));
	p = p->next;
	*(current_scope->var_value(p->item)) = atoms_add(s.init(t.wMinute));
	p = p->next;
	*(current_scope->var_value(p->item)) = atoms_add(s.init(t.wSecond));
	p = p->next;
	*(current_scope->var_value(p->item)) = atoms_add(s.init(t.wMilliseconds));
	p = p->next;
	*(current_scope->var_value(p->item)) = atoms_add(s.init(t.wDay));
	p = p->next;
	*(current_scope->var_value(p->item)) = atoms_add(s.init(t.wMonth));
	p = p->next;
	*(current_scope->var_value(p->item)) = atoms_add(s.init(t.wYear));

	char date [64];
	wsprintf(date, "%02i:%02i:%02i.%03i %02i-%02i-%04i",
		t.wHour, t.wMinute, t.wSecond, t.wMilliseconds, t.wDay, t.wMonth, t.wYear);

	return atoms_add(date);
}

atol_func(atol_eol)
{
	if (Args)
	{
		STR_S(s);
		for (register int i = Args->item->name.to_int(); i > 0; --i) s.concat(std_atom_EOL->name);
		return atoms_add(&s);
	}
	return std_atom_EOL;
}

atol_func(atol_rnd)
{
	STR_S(s);
	atom_s *symbols;
	if (Args->next) symbols = Args->next->item;
	else symbols = *(global_scope.var_value(std_atom_rnd_set));

	register char *symb = symbols->name.str;
	register unsigned int n = (unsigned int) symbols->name.len;

	for (register int i = Args->item->name.to_int(); i > 0; --i)
		s.append(symb [rnd() % n]);

	return atoms_add(&s);
}

atol_func(atol_shell)
{
	STR_S(cmd);
	for (register list_s *p = Args; p; p = p->next) cmd.concat(p->item->name);

	int ret = (DWORD) ShellExecute(NULL, NULL, cmd.str, NULL, NULL, SW_SHOWDEFAULT);

	cmd.free();

	return (ret <= 32)?std_atom_null:std_atom_true;
}

atol_func(atol_sleep)
{
	Sleep((DWORD) Args->item->name.to_int());
	return Args->item;
}

atol_func(atol_trace)
{
	console_write("%% Trace mode on\n");
	console_write("%% Keys: (c)ontinue or space; (s)kip; (n)otrace; (q)uit; (h)elp or ?.\n\n");
	return (++is_tracing == 1)?std_atom_null:std_atom_true;
}

atol_func(atol_notrace)
{
	register atom_s *res = is_tracing?std_atom_true:std_atom_null;
	is_tracing = 0;
	console_write("%% Trace mode off\n\n");
	return res;
}

atol_func(atol_gettag)
{
	str_s s;
	return atoms_add(s.init( Args->item->info & 0xFFFF ));
}

atol_func(atol_settag)
{
	Args->item->info |= (Args->next->item->name.to_int() & 0xFFFF);
	return Args->item;
}

atol_func(atol_call)
{
	list_s goal;
	goal.item = Args->item;
	goal.next = NULL;
	goal.sublist = Args->next;
	return engine_run_func(&goal, 1, 0);
}

atol_func(atol_spy)
{
	if (Args->item->flag(atom_info_spy)) return std_atom_true;
	Args->item->set_flag(atom_info_spy);
	return std_atom_null;
}

